Public Member Functions

# OGRPoint Class Reference

Point class. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRPoint:

List of all members.

## Public Member Functions
| OGRPoint ()
| Create a (0,0) point.
| OGRPoint (double x, double y)
| OGRPoint (double x, double y, double z)
virtual int | WkbSize () const
| Returns size of related binary representation.
virtual OGRErr | importFromWkb (unsigned char *, int=-1, OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data.
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known binary format.
virtual OGRErr | importFromWkt (char **)
| Assign geometry from well known text data.
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known text format.
virtual int | getDimension () const
| Get the dimension of this object.
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object.
virtual OGRGeometry * | clone () const
| Make a copy of this object.
virtual void | empty ()
| Clear geometry information.
virtual void | getEnvelope (OGREnvelope *psEnvelope) const
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.
virtual OGRBoolean | IsEmpty () const
| Returns TRUE (non-zero) if the object has no points.
double | getX () const
| Fetch X coordinate.
double | getY () const
| Fetch Y coordinate.
double | getZ () const
| Fetch Z coordinate.
virtual void | setCoordinateDimension (int nDimension)
| Set the coordinate dimension.
void | setX (double xIn)
| Assign point X coordinate.
void | setY (double yIn)
| Assign point Y coordinate.
void | setZ (double zIn)
| Assign point Z coordinate.
virtual OGRBoolean | Equals (OGRGeometry *) const
| Returns TRUE if two geometries are equivalent.
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect?
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment.
virtual const char * | getGeometryName () const
| Fetch WKT name for geometry type.
virtual OGRwkbGeometryType | getGeometryType () const
| Fetch geometry type.
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)
| Apply arbitrary coordinate transformation to geometry.
virtual void | flattenTo2D ()
| Convert geometry to strictly 2D.
virtual void | swapXY ()
| Swap x and y coordinates.

## Detailed Description

Point class.

Implements SFCOM IPoint methods.

## Member Function Documentation

OGRGeometry * OGRPoint::clone | ( |  | ) | const`[virtual]`

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns:
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

void OGRPoint::empty | ( |  | ) | `[virtual]`

Clear geometry information.

This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

OGRBoolean OGRPoint::Equals | ( | OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Returns TRUE if two geometries are equivalent.

This method is the same as the C function OGR_G_Equals().

Returns:
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

OGRErr OGRPoint::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | const`[virtual]`

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters:

  | eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  | eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

OGRErr OGRPoint::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | const`[virtual]`

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters:

  | ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with OGRFree().
  | eWkbVariant | the specification that must be conformed too : wbkVariantOgc for old-style 99-402 extended dimension (Z) WKB types wbkVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

void OGRPoint::flattenTo2D | ( |  | ) | `[virtual]`

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

int OGRPoint::getCoordinateDimension | ( |  | ) | const`[virtual]`

Get the dimension of the coordinates in this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method.

This method is the same as the C function OGR_G_GetCoordinateDimension().

Returns:
  in practice this will return 2 or 3. It can also return 0 in the case of an empty point.

Reimplemented from OGRGeometry.

int OGRPoint::getDimension | ( |  | ) | const`[virtual]`

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns:
  0 for points, 1 for lines and 2 for surfaces.

Implements OGRGeometry.

void OGRPoint::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const`[virtual]`

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters:

  | psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

void OGRPoint::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const`[virtual]`

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters:

  | psEnvelope | the structure in which to place the results.

Since:
  OGR 1.9.0

Implements OGRGeometry.

const char * OGRPoint::getGeometryName | ( |  | ) | const`[virtual]`

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns:
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implements OGRGeometry.

OGRwkbGeometryType OGRPoint::getGeometryType | ( |  | ) | const`[virtual]`

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns:
  the geometry type code.

Implements OGRGeometry.

double OGRPoint::getX | ( |  | ) | const`[inline]`

Fetch X coordinate.

Relates to the SFCOM IPoint::get_X() method.

Returns:
  the X coordinate of this point.

double OGRPoint::getY | ( |  | ) | const`[inline]`

Fetch Y coordinate.

Relates to the SFCOM IPoint::get_Y() method.

Returns:
  the Y coordinate of this point.

double OGRPoint::getZ | ( |  | ) | const`[inline]`

Fetch Z coordinate.

Relates to the SFCOM IPoint::get_Z() method.

Returns:
  the Z coordinate of this point, or zero if it is a 2D point.

OGRErr OGRPoint::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | `[virtual]`

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters:

  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.
  | eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

OGRErr OGRPoint::importFromWkt | ( | char ** | ppszInput | ) | `[virtual]`

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters:

  | ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

OGRBoolean OGRPoint::Intersects | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Do these features intersect?

Determines whether two geometries intersect. If GEOS is enabled, then this is done in rigerous fashion otherwise TRUE is returned if the envelopes (bounding boxes) of the two features overlap.

The poOtherGeom argument may be safely NULL, but in this case the method will always return TRUE. That is, a NULL geometry is treated as being everywhere.

This method is the same as the C function OGR_G_Intersects().

Parameters:

  | poOtherGeom | the other geometry to test against.

Returns:
  TRUE if the geometries intersect, otherwise FALSE.

Reimplemented from OGRGeometry.

OGRBoolean OGRPoint::IsEmpty | ( |  | ) | const`[virtual]`

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns:
  TRUE if object is empty, otherwise FALSE.

Implements OGRGeometry.

void OGRPoint::setCoordinateDimension | ( | int | nNewDimension | ) | `[virtual]`

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection will not necessarily affect the children geometries.

Parameters:

  | nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented from OGRGeometry.

void OGRPoint::setX | ( | double | xIn | ) | `[inline]`

Assign point X coordinate.

There is no corresponding SFCOM method.

void OGRPoint::setY | ( | double | yIn | ) | `[inline]`

Assign point Y coordinate.

There is no corresponding SFCOM method.

void OGRPoint::setZ | ( | double | zIn | ) | `[inline]`

Assign point Z coordinate.

Calling this method will force the geometry coordinate dimension to 3D (wkbPoint|wkbZ).

There is no corresponding SFCOM method.

void OGRPoint::swapXY | ( |  | ) | `[virtual]`

Swap x and y coordinates.

Since:
  OGR 1.8.0

Reimplemented from OGRGeometry.

OGRErr OGRPoint::transform | ( | OGRCoordinateTransformation * | poCT | ) | `[virtual]`

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters:

  | poCT | the transformation to apply.

Returns:
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

OGRBoolean OGRPoint::Within | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Test for containment.

Tests if actual geometry object is within the passed geometry.

This method is the same as the C function OGR_G_Within().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the geometry to compare to this geometry.

Returns:
  TRUE if poOtherGeom is within this geometry, otherwise FALSE.

Reimplemented from OGRGeometry.

int OGRPoint::WkbSize | ( |  | ) | const`[virtual]`

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns:
  size of binary representation in bytes.

Implements OGRGeometry.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrpoint.cpp

Generated for GDAL by 1.7.1.